TypeConverterSupport (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.beans

## Class TypeConverterSupport

- java.lang.Object
- - org.springframework.beans.PropertyEditorRegistrySupport
  - - org.springframework.beans.TypeConverterSupport

- All Implemented Interfaces:
    PropertyEditorRegistry, TypeConverter
  Direct Known Subclasses:
    AbstractPropertyAccessor, SimpleTypeConverter

      public abstract class TypeConverterSupport
      extends PropertyEditorRegistrySupport
      implements TypeConverter

  Base implementation of the `TypeConverter` interface, using a package-private delegate. Mainly serves as base class for `BeanWrapperImpl`.
  Since:
    3.2
  Author:
    Juergen Hoeller
  See Also:
    `SimpleTypeConverter`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TypeConverterSupport()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `<T> T` | `convertIfNecessary(Object value, Class<T> requiredType)` Convert the value to the required type (if necessary from a String).
    `<T> T` | `convertIfNecessary(Object value, Class<T> requiredType, Field field)` Convert the value to the required type (if necessary from a String).
    `<T> T` | `convertIfNecessary(Object value, Class<T> requiredType, MethodParameter methodParam)` Convert the value to the required type (if necessary from a String).

    - ### Methods inherited from class org.springframework.beans.PropertyEditorRegistrySupport

      `copyCustomEditorsTo, copyDefaultEditorsTo, findCustomEditor, getConversionService, getDefaultEditor, getPropertyType, guessPropertyTypeFromEditors, hasCustomEditorForElement, isSharedEditor, overrideDefaultEditor, registerCustomEditor, registerCustomEditor, registerDefaultEditors, registerSharedEditor, setConversionService, useConfigValueEditors`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TypeConverterSupport

          public TypeConverterSupport()

  - ### Method Detail

    - #### convertIfNecessary

          public <T> T convertIfNecessary(Object value,
                                 Class<T> requiredType)
                               throws TypeMismatchException

      Description copied from interface: `TypeConverter`
      Convert the value to the required type (if necessary from a String).

      Conversions from String to any type will typically use the `setAsText` method of the PropertyEditor class, or a Spring Converter in a ConversionService.

      Specified by:
        `convertIfNecessary` in interface `TypeConverter`
      Parameters:
        `value` - the value to convert
        `requiredType` - the type we must convert to (or `null` if not known, for example in case of a collection element)
      Returns:
        the new value, possibly the result of type conversion
      Throws:
        `TypeMismatchException` - if type conversion failed
      See Also:
        `PropertyEditor.setAsText(String)`, `PropertyEditor.getValue()`, `ConversionService`, `Converter`

    - #### convertIfNecessary

          public <T> T convertIfNecessary(Object value,
                                 Class<T> requiredType,
                                 MethodParameter methodParam)
                               throws TypeMismatchException

      Description copied from interface: `TypeConverter`
      Convert the value to the required type (if necessary from a String).

      Conversions from String to any type will typically use the `setAsText` method of the PropertyEditor class, or a Spring Converter in a ConversionService.

      Specified by:
        `convertIfNecessary` in interface `TypeConverter`
      Parameters:
        `value` - the value to convert
        `requiredType` - the type we must convert to (or `null` if not known, for example in case of a collection element)
        `methodParam` - the method parameter that is the target of the conversion (for analysis of generic types; may be `null`)
      Returns:
        the new value, possibly the result of type conversion
      Throws:
        `TypeMismatchException` - if type conversion failed
      See Also:
        `PropertyEditor.setAsText(String)`, `PropertyEditor.getValue()`, `ConversionService`, `Converter`

    - #### convertIfNecessary

          public <T> T convertIfNecessary(Object value,
                                 Class<T> requiredType,
                                 Field field)
                               throws TypeMismatchException

      Description copied from interface: `TypeConverter`
      Convert the value to the required type (if necessary from a String).

      Conversions from String to any type will typically use the `setAsText` method of the PropertyEditor class, or a Spring Converter in a ConversionService.

      Specified by:
        `convertIfNecessary` in interface `TypeConverter`
      Parameters:
        `value` - the value to convert
        `requiredType` - the type we must convert to (or `null` if not known, for example in case of a collection element)
        `field` - the reflective field that is the target of the conversion (for analysis of generic types; may be `null`)
      Returns:
        the new value, possibly the result of type conversion
      Throws:
        `TypeMismatchException` - if type conversion failed
      See Also:
        `PropertyEditor.setAsText(String)`, `PropertyEditor.getValue()`, `ConversionService`, `Converter`